"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const follow_redirects_1 = require("follow-redirects");
const gunzip_maybe_1 = __importDefault(require("gunzip-maybe"));
const os = __importStar(require("os"));
const path = __importStar(require("path"));
const tar_stream_1 = __importDefault(require("tar-stream"));
const create_request_data_1 = __importDefault(require("./download-code-helpers/create-request-data"));
const unpacker_1 = __importDefault(require("./download-code-helpers/unpacker"));
function default_1(organization, repository, sha, debug) {
    console.log('DOWNLOADING:', sha);
    return new Promise((resolve, reject) => {
        const requestData = create_request_data_1.default(organization, repository, sha);
        const request = follow_redirects_1.https.get(requestData, res => {
            const tarExtractor = tar_stream_1.default.extract();
            const unpacker = new unpacker_1.default(debug);
            tarExtractor.on('entry', unpacker.unpackEntry.bind(unpacker));
            tarExtractor.on('error', reject);
            tarExtractor.on('finish', function () {
                resolve(path.join(os.tmpdir(), `${organization}-${repository}-${sha}`));
            });
            res.pipe(gunzip_maybe_1.default()).pipe(tarExtractor);
        });
        request.on('error', reject);
    });
}
exports.default = default_1;
